• [LeetCode#244] Shortest Word Distance II


    Problem:

    This is a follow up of Shortest Word Distance. The only difference is now you are given the list of words and your method will be called repeatedly many times with different parameters. How would you optimize it?

    Design a class which receives a list of words in the constructor, and implements a method that takes two words word1 and word2 and return the shortest distance between these two words in the list.

    For example,
    Assume that words = ["practice", "makes", "perfect", "coding", "makes"].

    Given word1 = “coding”word2 = “practice”, return 3.
    Given word1 = "makes"word2 = "coding", return 1.

    Note:
    You may assume that word1 does not equal to word2, and word1 and word2 are both in the list.

    Analysis:

    This is an updated version of Shortest Word Distance.
    Since it would be called many times, we should not do the search in traditional O(n) way. 
    One apparent thing we should optimize is to reduce uncessary check and comparision. We should exclude the words that we are not care about.
    The instant idea is to use a hashmap.
    Key: the word;
    Value: a list of indexes associated with the word. 
    
    Through this way, we can get all information we want by retrieving the HashMap, and only use two realated list.
    ArrayList<Integer> list1 = map.get(word1);
    ArrayList<Integer> list2 = map.get(word2);
    
    Even though we narrow down the elements we need to search, there could be a efficiency pitfall if we fail to implement it rightly.
    
    Traditionally we would try to search the shortest distance through following way. 
    for (int i = 0; i < list1.length(); i++) {
        for (int j = 0; j < list2.length(); j++) {
            min = Math.min(min, Math.abs(j - i));
        }
    }
    Apparently, at the worst case, the time complexity is O(n^2), which is even worse than our previous solution.
    Why? Cause there are many uncessary comparisions.
    ---------------------------------------------------------------------------------------------------------------
    word 1: [1, 5, 8]
    word 2: [2, 10]
    Since we have already compared min with |2-1|, why we still need to compare |8-1|, since all elements after 2 must have larger distance than |2-1| (with 1 fixed). It seems I get used with "for-loop" method to scan lists, while ignoring we actually could also use "while-loop" over two lists.
    -------------------------------------------------------------------
    while (i < m && j < n) {
        min = Math.min(min, Math.abs(list1.get(i)-list2.get(j)));
        if (list1.get(i) < list2.get(j))
            i++;
        else
            j++;
        }
    }
    -------------------------------------------------------------------
    The reason we could see the example:
    word 1: [1, 5, 8]
    word 2: [2, 10]
    After we finished the scan: "1, 2",
    "1" is no longer could have combination "1, x (x > 2)" has shorter distance than "1, 2".

    Solution:

    public class WordDistance {
        HashMap<String, ArrayList<Integer>> map = new HashMap<String, ArrayList<Integer>> ();
        public WordDistance(String[] words) {
            for (int i = 0; i < words.length; i++) {
                String word = words[i];
                if (map.containsKey(word)) {
                    map.get(word).add(i);
                } else{
                    ArrayList<Integer> item = new ArrayList<Integer> ();
                    item.add(i);
                    map.put(word, item);
                }
            }
        }
    
        public int shortest(String word1, String word2) {
            ArrayList<Integer> list1 = map.get(word1);
            ArrayList<Integer> list2 = map.get(word2);
            int i = 0, j = 0;
            int min = Integer.MAX_VALUE;
            int m = list1.size();
            int n = list2.size();
            while (i < m && j < n) {
                min = Math.min(min, Math.abs(list1.get(i)-list2.get(j)));
                if (list1.get(i) < list2.get(j))
                    i++;
                else
                    j++;
            }
            return min;
        }
    }
  • 相关阅读:
    Codeforces Round #455 (Div. 2) A. Generate Login【贪心】
    Codeforces Round #315 (Div. 2)【贪心/重排去掉大于n的元素和替换重复的元素】
    CSU-ACM2018寒假集训选拔-入门题
    Codeforces Round #454 C. Shockers【模拟/hash】
    Nowcoder Girl 参考题解【待写】
    2017吉首大学新生赛
    P1450 包裹快递 RP+14【二分】
    NewCode
    2017年浙江工业大学大学生程序设计迎新赛决赛题解
    Codeforces Round #451 (Div. 2) B. Proper Nutrition【枚举/扩展欧几里得/给你n问有没有两个非负整数x,y满足x·a + y·b = n】
  • 原文地址:https://www.cnblogs.com/airwindow/p/4805950.html
Copyright © 2020-2023  润新知